#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

// Проверка, является ли строка числом (целым или с плавающей точкой)
int je_cislo(const char *str) {
    char *endptr;
    strtod(str, &endptr);
    return *endptr == '\0';
}

// Чтение числа с проверкой, если ошибка — вывод сообщения и завершение программы
double citaj_cislo(int poradie) {
    char buffer[100];
    if (fgets(buffer, sizeof(buffer), stdin) == NULL) {
        if (poradie == 0) {
            fprintf(stderr, "Chyba: Nepodarilo sa nacitat hodnotu x.\n");
        } else {
            fprintf(stderr, "Chyba: Nepodarilo sa nacitat koeficient c.%d.\n", poradie);
        }
        exit(1);
    }

    // Убираем перевод строки
    char *newline = strchr(buffer, '\n');
    if (newline) *newline = '\0';

    // Пустая строка — конец ввода коэффициентов
    if (buffer[0] == '\0') {
        return 0.0 / 0.0;  // Возвращаем NaN как сигнал конца ввода
    }

    if (!je_cislo(buffer)) {
        if (poradie == 0) {
            fprintf(stderr, "Chyba: Nepodarilo sa nacitat hodnotu x.\n");
        } else {
            fprintf(stderr, "Chyba: Nepodarilo sa nacitat koeficient c.%d.\n", poradie);
        }
        exit(1);
    }

    return atof(buffer);
}

// Горнерова схема
double hornerova_schema(double *koef, int n, double x) {
    double vysledok = 0.0;
    for (int i = 0; i < n; i++) {
        vysledok = vysledok * x + koef[i];
    }
    return vysledok;
}

int main() {
    double x;
    double koef[100];  // максимум 100 коэффициентов, можно увеличить при необходимости
    int n = 0;

    // Чтение x
    x = citaj_cislo(0);

    // Чтение коэффициентов
    while (1) {
        double koeficient = citaj_cislo(n + 1);
        if (koeficient != koeficient) {  // Если NaN, это конец ввода
            break;
        }
        koef[n++] = koeficient;

        if (n >= 100) {
            fprintf(stderr, "Chyba: Prilis vela koeficientov.\n");
            exit(1);
        }
    }

    if (n == 0) {
        fprintf(stderr, "Chyba: Neboli zadane ziadne koeficienty.\n");
        return 1;
    }

    // Вычисление и вывод результата
    double vysledok = hornerova_schema(koef, n, x);
    printf("Vysledok je: %.2f\n", vysledok);

    return 0;
}
